﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Mode As String
End Sub

Sub Globals
	Private edtFirstName, edtLastName, edtCity As EditText
	Private lblRowID As Label
	Private btnAdd, btnDelete, btnUpdate, btnPrevious, btnNext, btnFirst, btnLast As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Edit")
	Activity.Title = "SQLiteLight2  Edit"
End Sub

Sub Activity_Resume
	If Main.CurrentIndex > -1 Then
		ShowEntry(Main.CurrentIndex)				'show the first entry
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Private Sub ShowEntry(EntryIndex As Int)
	Private RowID As Int
	
	If Main.RowIDList.Size = 0 Then 			'check if database is empty
		Return													'if the database is empty leave the routine
	End If
	
	If Mode = "Add" Then
		lblRowID.Text = ""
		edtFirstName.Text = ""
		edtLastName.Text = ""
		edtCity.Text = ""
	Else
		Private ResultSet1 As ResultSet
		RowID = Main.RowIDList.Get(EntryIndex)		'get the rowid for the given entry index
		'read the entry with the given ID
		ResultSet1 = Main.SQL1.ExecQuery("SELECT * FROM persons WHERE rowid = " & RowID)
		lblRowID.Text = RowID																	'display the ID
		ResultSet1.NextRow
		edtFirstName.Text = ResultSet1.GetString("FirstName")		'read the value of the FirstName column
		edtLastName.Text = ResultSet1.GetString("LastName")			'read the value of the LasstName column
		edtCity.Text = ResultSet1.GetString("City")							'read the value of the City column
		ResultSet1.Close																				'close the ResultSet, we don't need it anymore
	End If
	ShowButtons
End Sub

Private Sub AddEntry
	Private Query As String
	Private ResultSet1 As ResultSet
	Private RowID As Int
	
	'first we check if the entry already does exist
	Query = "SELECT * FROM persons WHERE FirstName = ? AND LastName = ? AND City = ?"
	ResultSet1 = Main.SQL1.ExecQuery2(Query, Array As String (edtFirstName.Text, edtLastName.Text, edtCity.Text))

	If ResultSet1.NextRow = True Then
		'if it exists show a message and do nothing else
		ToastMessageShow("This entry already exists", False)
	Else
		'if not, add the entry
		'we use ExecNonQuery2 because it's easier, we don't need to take care of the data types 
		Query = "INSERT INTO persons VALUES (?, ?, ?)"
		Main.SQL1.ExecNonQuery2(Query, Array As String(edtFirstName.Text, edtLastName.Text, edtCity.Text))
		
		ToastMessageShow("Entry added", False)	' confirmation for the user
		
		'to display the rowid of the last entry we read the max value of the rowid column 
		RowID = Main.SQL1.ExecQuerySingleResult("SELECT max(rowid) FROM persons")
		Main.RowIDList.Add(RowID)											'add the last rowid to the list
		Main.CurrentIndex = Main.RowIDList.Size - 1		'set the current index to the last one
		lblRowID.Text = RowID										'display the last index
	End If
	ResultSet1.Close													'close the ResultSet, we don't need it anymore
	
	ShowButtons
End Sub

Private Sub DeleteEntry
	Private Query As String
	Private Answ As Int
	
	'ask the user for confirmation
	Answ = Msgbox2("Do you really want to delete " & edtFirstName.Text & " " & edtLastName.Text, "Delete entry", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then			'if yes, delete the entry
		Query = "DELETE FROM persons WHERE rowid = " & Main.RowIDList.Get(Main.CurrentIndex)
		Main.SQL1.ExecNonQuery(Query)									'delete the entry
		Main.RowIDList.RemoveAt(Main.CurrentIndex)							'remove the rowid from the list
		If Main.CurrentIndex = Main.RowIDList.Size - 1 Then			'if the current index is the last one
			Main.CurrentIndex = Main.CurrentIndex - 1					'decrement it by 1
		End If
		ShowEntry(Main.CurrentIndex)										'show the next entry
		ToastMessageShow("Entry deleted", False)	'confirmation for the user
		ShowButtons
	End If
End Sub

Private Sub UpdateEntry
	Private Query As String
	
	Query = "UPDATE persons Set FirstName = ?, LastName = ?, City = ? WHERE rowid = " & Main.RowIDList.Get(Main.CurrentIndex)
	Main.SQL1.ExecNonQuery2(Query, Array As String(edtFirstName.Text, edtLastName.Text, edtCity.Text))
	ToastMessageShow("Entry updated", False)
End Sub

Private Sub btnAdd_Click
	AddEntry
	Mode = "Edit"
	ShowButtons
End Sub

Private Sub btnDelete_Click
	DeleteEntry
End Sub

Private Sub btnUpdate_Click
	UpdateEntry
End Sub

Private Sub btnMove_Click
	Private btn As Button
	Private Tag As String
	
	btn = Sender
	Tag = btn.Tag
	
	Select Tag
		Case "First"
			Main.CurrentIndex = 0
		Case "Prev"
			If Main.CurrentIndex > 0 Then
				Main.CurrentIndex = Main.CurrentIndex - 1
			End If		
		Case "Next"
			If Main.CurrentIndex < Main.RowIDList.Size Then
				Main.CurrentIndex = Main.CurrentIndex + 1
			End If
		Case "Last"
			Main.CurrentIndex = Main.RowIDList.Size - 1
	End Select
	ShowEntry(Main.CurrentIndex)
End Sub

Private Sub ShowButtons
	If Mode = "Add" Then
		btnPrevious.Visible = False		'hide the navigation buttons
		btnNext.Visible = False
		btnFirst.Visible = False
		btnLast.Visible = False
		btnDelete.Visible = False
		btnUpdate.Visible = False
	Else
		btnDelete.Visible = True
		btnUpdate.Visible = True
		If Main.RowIDList.Size <= 1 Then 	'check if the database has less than 2 entries
			btnPrevious.Visible = False					'hide the navigation buttons
			btnNext.Visible = False
			btnFirst.Visible = False
			btnLast.Visible = False
		Else
			'show or hide the Previous and Next buttons depending on the value of the current index
			If Main.CurrentIndex = 0 Then			
				btnPrevious.Visible = False
				btnFirst.Visible = False
			Else
				btnPrevious.Visible = True
				btnFirst.Visible = True
			End If
			
			If Main.CurrentIndex = Main.RowIDList.Size - 1 Then
				btnNext.Visible = False
				btnLast.Visible = False
			Else
				btnNext.Visible = True
				btnLast.Visible = True
			End If
		End If
	End If
End Sub

Private Sub edtFirstName_FocusChanged (HasFocus As Boolean)
	If HasFocus = True Then
		edtFirstName.SelectAll
	End If
End Sub

Private Sub edtLastName_FocusChanged (HasFocus As Boolean)
	If HasFocus = True Then
		edtLastName.SelectAll
	End If
End Sub

Private Sub edtCity_FocusChanged (HasFocus As Boolean)
	If HasFocus = True Then
		edtCity.SelectAll
	End If
End Sub

